



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】PowerShell入门（十二）：编写PowerShell管理单元和二进制模块</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】PowerShell入门（十二）：编写PowerShell管理单元和二进制模块</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 08:01:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转至：http://www.cnblogs.com/ceachy/archive/2013/03/13/PowerShell_SnapIn.html</p>
<p>PowerShell一开始就提出利用管理单元来实现自定义cmdlet，为大型软件系统提供有别于UI界面的脚本化管理方案。在PowerShell V2中，PowerShell管理单元还能以二进制模块的方式处理。</p>
<h3>编写管理单元</h3>
<p>　　编写PowerShell管理单元需要依赖System.Management.Automation程序集；而System.Management.Automation程序集是Windows SDK的一部分，所以安装Windows SDK是编写PowerShell管理单元的先决条件。可以从<a href="http://www.microsoft.com/en-us/download/details.aspx?id=8279" rel="external nofollow noreferrer">这里</a>下载Windows SDK。</p>
<p>　　作为编写PowerShell管理单元的准备，我们先打开VS2008或者VS2010，创建一个类库项目，目标.Net Framework版本选择3.5。简单编译通过之后，就可以编写cmdlet命令类和SnapIn安装类了。</p>
<h4>编写cmdlet类</h4>
<p>　　自定义cmdlet类有以下几个步骤：</p>
<p>　　1、在项目中添加对System.Management.Automation程序集的引用（路径是C:\Program Files\Reference Assemblies\Microsoft\WindowsPowerShell\v1.0\System.Management.Automation.dll）；并且添加相应命令空间的引用using System.Management.Automation；</p>
<p>　　2、创建名为New-Addition的类，添加对命令空间System.Management.Automation的引用；</p>
<p>　　3、让New-Addition类继承自PSCmdlet，并给New-Addition类添加Cmdlet属性标记，设置动词和名词；</p>
<p>　　4、添加参数信息，参数一定要用Parameter属性标记；</p>
<p>　　5、重载ProcessRecord函数，实现自己的业务逻辑；</p>
<p>编写cmdlet类的示例如下（本文示例参考了<a href="http://www.cnblogs.com/blogs/ivorb/default.aspx" rel="external nofollow noreferrer">Ivor Bright's blog</a>）：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">using System;<br />
using System.Management.Automation;

namespace PSSnapInDemo1<br />
{<br />
    [Cmdlet(VerbsCommon.New, "Addition")]<br />
    public class New_Addition: PSCmdlet<br />
    {<br />
        [Alias("X")]<br />
        [Parameter(Mandatory = true, ValueFromPipelineByPropertyName = true)]<br />
        public int FirstParameter { get; set; }

        [Alias("Y")]<br />
        [Parameter(Mandatory = true, ValueFromPipelineByPropertyName = true)]<br />
        public int SecondParameter { get; set; }

        protected override void ProcessRecord()<br />
        {<br />
            WriteObject(string.Format("{0} + {1} = {2}", this.FirstParameter, this.SecondParameter,<br />
                this.FirstParameter + this.SecondParameter));<br />
        }<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>编译通过后，自定义的cmdlet类就完成了，接下来就可以编写PSSnapIn安装类了。</p>
<h4>编写PSSnapIn安装类</h4>
<p>　　编写PSSnapIn安装类的目的是使该类库能够被安装，并且被系统识别为PowerShell管理单元。步骤如下：</p>
<p>　　1、添加对System.Configuration.Install程序集的引用；</p>
<p>　　2、创建名为PSSnapInInstaller的类，添加对命名空间System.ComponentModel和System.Management.Automation的引用；</p>
<p>　　3、让PSSnapInInstaller类继承自PSSnapIn，并且以RunInstaller(true)属性标识它。</p>
<p>　　4、重载Name、Vendor和Description三个属性；</p>
<p>示例如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">using System;<br />
using System.Management.Automation;<br />
using System.ComponentModel;

namespace PSSnapInDemo1<br />
{<br />
    [RunInstaller(true)]<br />
    public class PSSnapInInstaller : PSSnapIn<br />
    {<br />
        public override string Description<br />
        {<br />
            get { return "This is Luke's first Snap In demo"; }<br />
        }

        public override string Name<br />
        {<br />
            get { return "PSSnapInDemo1"; }<br />
        }

        public override string Vendor<br />
        {<br />
            get { return "CaiJu"; }<br />
        }<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>编译通过以后，PSSnapIn安装类也完成了，这样我们编写代码的工作就全部完成了。编译整个解决方案，生成类库文件。</p>
<h3>使用管理单元</h3>
<p>　　编写好的管理单元，在使用之前需要先注册。注册流程如下：</p>
<p>　　1、打开Visual Studio自带的命名行，并且导航到PSSnapInDemo1.dll的目录中；</p>
<p>　　2、执行&ldquo;installUtil /i PSSnapInDemo1.dll&rdquo;命令；</p>
<p>如上命令如果成功执行，注册过程就完成了；如果不成功，请仔细检查安装过程的log文件。</p>
<p>　　PowerShell管理单元注册成功后，就可以将其添加到当前会话中使用了。查找已经注册的PowerShell管理单元，可用以下命令：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">PS C:\Users\luke&gt; Get-PSSnapin -Registered | ft

Name                           PSVersion            Description<br />
----                           ---------            -----------<br />
PSSnapInDemo1                  2.0                  This is Luke's first Snap I...<br />
SqlServerCmdletSnapin100       2.0                  This is a PowerShell snap-i...<br />
SqlServerProviderSnapin100     2.0                  SQL Server Provider</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>以上命令的输出结果已经显示出了我们刚刚注册的PowerShell管理单元，添加管理单元使用如下命令：</p>
<div>
<pre class="prettyprint linenums">PS C:\Users\luke&gt; Add-PSSnapin -Name PSSnapInDemo1</pre>
</div>
<p>PowerShell管理单元添加成功后，就可以使用其中的命令了，使用方法与使用系统自带的cmdlet命令相同。</p>
<h3>编写二进制模块</h3>
<p>　　编写二进制模块的编写与编写管理单元的方法基本相同，都需要实现cmdlet类，但它不需要实现安装类。具体方法参见上述编写cmdlet类的步骤。需要说明的是，同时实现了PSSnapIn类的类库，仍然可以当作二进制模块来使用。也就是说，PowerShell管理单元的程序集文件，可以不加修改的当成二进制模块的程序集来使用。</p>
<h4>使用二进制模块</h4>
<p>　　二进制模块的使用与<a href="http://www.cnblogs.com/ceachy/archive/2013/03/08/PowerShell_Script_Module.html" rel="external nofollow noreferrer">PowerShell入门（十一）：编写脚本模块</a>中脚本模块的使用方法相同，即在搜索目录下创建同名文件夹，并将程序集拷贝进去，可选创建描述文件等；然后查找和导入模块。之后，二进制模块中的命令就可以使用了。</p>
<h3>结语</h3>
<p>　　除了自定义cmdlet外，PowerShell管理单元还可以编写自定义提供程序。提供程序是一个更高级别的概念，系统预定义的有文件系统、注册表和证书等。不过，PowerShell管理单元中不能定义别名和变量，如果你需要这些功能，可以选择使用脚本模块。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvj5gzq.html">M2事后分析汇报总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93k6jgq.html">Bzoj1455 罗马游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12e209.html">HTML5 web Form表单验证实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ov6v8.html">尝试在tensorflow上运行facenet</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kyvv39.html">Java系列： JAVA字符串格式化-String&period;format&lpar;&rpar;的使用（zz）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39re7eeq.html">NetBios网络基础及编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mxx1kq.html">configs for postgresql restart and postgresql reload</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1x73k8.html">导出EXCEL&lpar;转转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkj069.html">Linux基础（4）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z65ke9.html">MySQL5&period;6中date和string的转换和比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrd309.html">Java基础之 数组详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp31e69.html">Android 常用知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1r22e9.html">Git 设置过滤忽略的文件或文件夹&lpar;ignore file&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldrneq.html">C&plus;&plus; 重载运算符和重载函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24xr2q.html">&lbrack;archlinux&rsqb;&lbrack;crypto&rsqb; 从T450迁移archlinux操作系统至T460s笔记本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv215gq.html">8 -- 深入使用Spring -- 2&period;&period;&period;4 使用&commat;PostConstruct和&commat;PreDestroy定制生命周期行为</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngkx2q.html">Xcode 5&period;1 编译模拟器以及真机都能使用的静态库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjv7j68.html">Action中如何通过&commat;Autowired自动注入spring bean ？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvmrn2q.html">HDP安全之集成kerberos&sol;LDAP、ranger（knox自带LDAP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koyyzrq.html">表A中一条记录的两个字段都对应于表B的同一个字段 如何查询？SQL&comma; thinkphp&lbrack;5&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mdgdp8.html">java接口的嵌套</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnd3o38.html">java并发编程（四）守护进程 线程阻塞的四种情况</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8km3d79.html">如何在移动设备上调试html5开发的网页</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g41kl9.html">Random随机类&lpar;11选5彩票&rpar;BigInteger大数据类&lpar;华为面试题1000的阶乘&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mle4r9.html">PBOC2&period;0中消费交易流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7lovx8.html">How to only capute sub-matched character by grep</a>
			</li>
						<li><a href="https://www.batexi.com/a/390jr3j8.html">php 获取数组第一个元素 以及最后一个元素 &amp;amp&semi;&amp;amp&semi; 最后一个元素的键名</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqln5me8.html">Python实现简单的记账本功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kn52r8.html">vim - mark</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn2yj3q.html">java 读写文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
